QA updates - make builds on older versions of headers work, reenable rt on bruce.
[xfstests-dev.git] / common.rc
index 8f748b58dcdc3dcd715422193ef48cd65fb6f46a..d6682d2648627b6e0ae67fc65207d541986e0f7f 100644 (file)
--- a/common.rc
+++ b/common.rc
@@ -1,37 +1,41 @@
 ##/bin/sh
-
+#-----------------------------------------------------------------------
+#  Copyright (c) 2000-2005 Silicon Graphics, Inc.  All Rights Reserved.
+#  This program is free software; you can redistribute it and/or modify
+#  it under the terms of the GNU General Public License as published by
+#  the Free Software Foundation; either version 2 of the License, or
+#  (at your option) any later version.
+#
+#  This program is distributed in the hope that it will be useful,
+#  but WITHOUT ANY WARRANTY; without even the implied warranty of
+#  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+#  GNU General Public License for more details.
 #
-# Copyright (c) 2000-2003 Silicon Graphics, Inc.  All Rights Reserved.
-# 
-# This program is free software; you can redistribute it and/or modify it
-# under the terms of version 2 of the GNU General Public License as
-# published by the Free Software Foundation.
-# 
-# This program is distributed in the hope that it would be useful, but
-# WITHOUT ANY WARRANTY; without even the implied warranty of
-# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
-# 
-# Further, this software is distributed without any warranty that it is
-# free of the rightful claim of any third person regarding infringement
-# or the like.  Any license provided herein, whether implied or
-# otherwise, applies only to this software file.  Patent licenses, if
-# any, provided herein do not apply to combinations of this program with
-# other software, or any other product whatsoever.
-# 
-# You should have received a copy of the GNU General Public License along
-# with this program; if not, write the Free Software Foundation, Inc., 59
-# Temple Place - Suite 330, Boston MA 02111-1307, USA.
-# 
-# Contact information: Silicon Graphics, Inc., 1600 Amphitheatre Pkwy,
-# Mountain View, CA  94043, or:
-# 
-# http://www.sgi.com 
-# 
-# For further information regarding this notice, see: 
-# 
-# http://oss.sgi.com/projects/GenInfo/SGIGPLNoticeExplan/
+#  You should have received a copy of the GNU General Public License
+#  along with this program; if not, write to the Free Software
+#  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307
+#  USA
 #
+#  Contact information: Silicon Graphics, Inc., 1500 Crittenden Lane,
+#  Mountain View, CA 94043, USA, or: http://www.sgi.com
+#-----------------------------------------------------------------------
 
+dd()
+{
+   if [ "$HOSTOS" == "Linux" ]
+   then        
+       command dd --help | grep noxfer > /dev/null 2>&1
+       
+       if [ "$?" -eq 0 ]
+           then
+               command dd status=noxfer $@
+           else
+               command dd $@
+       fi
+   else
+       command dd $@
+   fi
+}
 
 _mount_opts()
 {
@@ -153,19 +157,19 @@ _scratch_mount()
 
 _test_mount()
 {
-    _test_options mount 
+    _test_options mount
     _mount -t $FSTYP $TEST_OPTIONS $MOUNT_OPTIONS $* $TEST_DEV $TEST_DIR
 }
 
 _scratch_mkfs_options()
 {
-    _scratch_options mkfs 
+    _scratch_options mkfs
     echo $SCRATCH_OPTIONS $MKFS_OPTIONS $* $SCRATCH_DEV
 }
 
 _scratch_mkfs_xfs()
 {
-    _scratch_options mkfs 
+    _scratch_options mkfs
 
     $MKFS_XFS_PROG $SCRATCH_OPTIONS $MKFS_OPTIONS $* $SCRATCH_DEV
     mkfs_status=$?
@@ -187,8 +191,11 @@ _scratch_mkfs()
     nfs*)
        # do nothing for nfs
        ;;
-    udf|*)
-        $MKFS_PROG -t $FSTYP $MKFS_OPTIONS $* > /dev/null
+    udf)
+        $MKFS_UDF_PROG $MKFS_OPTIONS $* $SCRATCH_DEV > /dev/null
+       ;;
+    *)
+       /sbin/mkfs -t $FSTYP -- $MKFS_OPTIONS $* $SCRATCH_DEV > /dev/null
        ;;
     esac
 }
@@ -214,6 +221,8 @@ _scratch_xfs_repair()
     SCRATCH_OPTIONS=""
     [ "$USE_EXTERNAL" = yes -a ! -z "$SCRATCH_LOGDEV" ] && \
         SCRATCH_OPTIONS="-l$SCRATCH_LOGDEV"
+    [ "$USE_EXTERNAL" = yes -a ! -z "$SCRATCH_RTDEV" ] && \
+        SCRATCH_OPTIONS=$SCRATCH_OPTIONS" -r$SCRATCH_RTDEV"
     [ "$USE_BIG_LOOPFS" = yes ] && SCRATCH_OPTIONS=$SCRATCH_OPTIONS" -t"
     $XFS_REPAIR_PROG $SCRATCH_OPTIONS $* $SCRATCH_DEV
 }
@@ -286,7 +295,7 @@ _need_to_be_root()
 
 
 #
-# _df_device : get an IRIX style df line for a given device 
+# _df_device : get an IRIX style df line for a given device
 #
 #       - returns "" if not mounted
 #       - returns fs type in field two (ala IRIX)
@@ -301,9 +310,9 @@ _df_device()
        echo "Usage: _df_device device" 1>&2
        exit 1
     fi
-    
+
     $DF_PROG 2>/dev/null | $AWK_PROG -v what=$1 '
-        match($1,what) && NF==1 { 
+        match($1,what) && NF==1 {
             v=$1
             getline
             print v, $0
@@ -331,11 +340,11 @@ _df_dir()
        echo "Usage: _df_dir device" 1>&2
        exit 1
     fi
-    
+
     $DF_PROG $1 2>/dev/null | $AWK_PROG -v what=$1 '
-        NR == 2 && NF==1 { 
+        NR == 2 && NF==1 {
             v=$1
-            getline 
+            getline
             print v, $0;
             exit 0
         }
@@ -357,7 +366,7 @@ _used()
        echo "Usage: _used device" 1>&2
        exit 1
     fi
-    
+
     _df_device $1 | $AWK_PROG '{ sub("%", "") ; print $6 }'
 }
 
@@ -370,7 +379,7 @@ _fs_type()
        echo "Usage: _fs_type device" 1>&2
        exit 1
     fi
-    
+
     _df_device $1 | $AWK_PROG '{ print $2 }'
 }
 
@@ -387,11 +396,10 @@ _fs_options()
        echo "Usage: _fs_options device" 1>&2
        exit 1
     fi
-    
+
     $AWK_PROG -v dev=$1 '
         match($1,dev) { print $4 }
     ' </proc/mounts
-    
 }
 
 # returns device number if a file is a block device
@@ -403,7 +411,7 @@ _is_block_dev()
        echo "Usage: _is_block_dev dev" 1>&2
        exit 1
     fi
-    
+
     [ -b $1 ] && src/lstat64 $1 | $AWK_PROG '/Device type:/ { print $9 }'
 }
 
@@ -453,7 +461,7 @@ _do()
 }
 
 # bail out, setting up .notrun file
-# 
+#
 _notrun()
 {
     echo "$*" >$seq.notrun
@@ -463,7 +471,7 @@ _notrun()
 }
 
 # just plain bail out
-# 
+#
 _fail()
 {
     echo "$*" | tee -a $here/$seq.full
@@ -503,7 +511,7 @@ _supported_os()
 }
 
 # this test needs a scratch partition - check we're ok & unmount it
-# 
+#
 _require_scratch()
 {
     case "$FSTYP" in
@@ -512,13 +520,12 @@ _require_scratch()
                 then
                     _notrun "this test requires a valid \$SCRATCH_DEV"
                 fi
-                
                 if [ "`_is_block_dev $SCRATCH_DEV`" = "`_is_block_dev $TEST_DEV`" ]
                 then
                     _notrun "this test requires a valid \$SCRATCH_DEV"
                 fi
                 ;;
-       nfs*)
+       nfs*|ext2|ext3|reiserfs)
                 echo $SCRATCH_DEV | grep -q ":" > /dev/null 2>&1
                 if [ ! -z "$SCRATCH_DEV" -a ! -b "$SCRATCH_DEV" -a "$?" != "0" ]
                 then
@@ -530,13 +537,12 @@ _require_scratch()
                 ;;
     esac
 
-    
     # mounted?
     if _mount | grep -q $SCRATCH_DEV
-    then 
+    then
         # if it's mounted, make sure its on $SCRATCH_MNT
         if ! _mount | grep $SCRATCH_DEV | grep -q $SCRATCH_MNT
-        then 
+        then
             echo "\$SCRATCH_DEV is mounted but not on \$SCRATCH_MNT - aborting"
             exit 1
         fi
@@ -549,12 +555,12 @@ _require_scratch()
     fi
 }
 
-# this test needs a logdev 
-# 
+# this test needs a logdev
+#
 _require_logdev()
 {
     [ -z "$SCRATCH_LOGDEV" -o ! -b "$SCRATCH_LOGDEV" ] && \
-        _notrun "This test requires a valid \$SCRATCH_LOGDEV" 
+        _notrun "This test requires a valid \$SCRATCH_LOGDEV"
     [ "$USE_EXTERNAL" != yes ] && \
         _notrun "This test requires USE_EXTERNAL to be enabled"
 
@@ -563,7 +569,7 @@ _require_logdev()
 }
 
 # this test requires loopback device support
-# 
+#
 _require_loop()
 {
     if [ "$HOSTOS" != "Linux" ]
@@ -581,15 +587,33 @@ _require_loop()
 }
 
 # this test requires that (large) loopback device files are not in use
-# 
+#
 _require_nobigloopfs()
 {
     [ "$USE_BIG_LOOPFS" = yes ] && \
        _notrun "Large filesystem testing in progress, skipped this test"
 }
 
+# this test requires that a realtime subvolume is in use, and
+# that the kernel supports realtime as well.
+#
+_require_realtime()
+{
+    [ "$USE_EXTERNAL" = yes ] || \
+       _notrun "External volumes not in use, skipped this test"
+    [ "$SCRATCH_RTDEV" = "" ] && \
+       _notrun "Realtime device required, skipped this test"
+}
+
+# this test requires that a specified command (executable) exists
+#
+_require_command()
+{
+    [ -x "$1" ] || _notrun "$1 utility required, skipped this test"
+}
+
 # this test requires that external log/realtime devices are not in use
-# 
+#
 _require_nonexternal()
 {
     [ "$USE_EXTERNAL" = yes ] && \
@@ -605,9 +629,9 @@ _xfs_mounted()
        echo "Usage: _xfs_mounted device" 1>&2
        exit 1
     fi
-    
+
     device=$1
-    
+
     if _mount | grep $device | $AWK_PROG '
         /type xfs/  { print $3 ; exit 0 }
         END         { exit 1 }
@@ -630,7 +654,7 @@ _remount()
     fi
     device=$1
     mode=$2
-    
+
     if ! mount -o remount,$mode $device
     then
         echo "_remount: failed to remount filesystem on $device as $mode"
@@ -638,7 +662,7 @@ _remount()
     fi
 }
 
-# run xfs_check and friends on a FS. 
+# run xfs_check and friends on a FS.
 #
 # if the filesystem is mounted, it's either remounted ro before being
 # checked or it's unmounted and then remounted
@@ -648,29 +672,35 @@ USE_REMOUNT=0
 
 _check_xfs_filesystem()
 {
-    if [ $# -ne 1 -a $# -ne 2 ]
+    if [ $# -ne 3 ]
     then
-       echo "Usage: _check_fs device [logdevice]" 1>&2
+       echo "Usage: _check_xfs_filesystem device <logdev>|none <rtdev>|none" 1>&2
        exit 1
     fi
-    
+
     device=$1
-    if [ $# -eq 2 -a "$2" != "" ]; then
+    if [ "$2" != "none" ]; then
                extra_log_options="-l$2"
         extra_mount_options="-ologdev=$2"
     fi
 
+    if [ "$3" != "none" ]; then
+               extra_rt_options="-r$3"
+        extra_mount_options=$extra_mount_options" -ortdev=$3"
+    fi
+    extra_mount_options=$extra_mount_options" $MOUNT_OPTIONS"
+
     [ "$FSTYP" != xfs ] && return 0
     testoption=""
     [ "$USE_BIG_LOOPFS" = yes ] && testoption=-t
 
     type=`_fs_type $device`
     ok=1
-    
+
     if [ "$type" = "xfs" ]
     then
-        # mounted... 
-        
+        # mounted...
+
         if [ $USE_REMOUNT -eq 0 ]
         then
             mountpoint=`_xfs_mounted $device`
@@ -684,45 +714,45 @@ _check_xfs_filesystem()
                 | tee $tmp.logprint | grep -q "<CLEAN>"
     if [ $? -ne 0 -a "$HOSTOS" = "Linux" ]
     then
-        echo "_check_fs: filesystem on $device has dirty log (see $seq.full)"
-        
-        echo "_check_fs: filesystem on $device has dirty log"   >>$here/$seq.full
+        echo "_check_xfs_filesystem: filesystem on $device has dirty log (see $seq.full)"
+
+        echo "_check_xfs_filesystem: filesystem on $device has dirty log"   >>$here/$seq.full
         echo "*** xfs_logprint -t output ***"                   >>$here/$seq.full
         cat $tmp.logprint                                       >>$here/$seq.full
         echo "*** end xfs_logprint output"                      >>$here/$seq.full
-        
+
         ok=0
     fi
 
     $XFS_CHECK_PROG $testoption $extra_log_options $device 2>&1 |\
-        _fix_malloc >$tmp.fs_check 
+        _fix_malloc >$tmp.fs_check
     if [ -s $tmp.fs_check ]
     then
-        echo "_check_fs: filesystem on $device is inconsistent (c) (see $seq.full)"
-        
-        echo "_check_fs: filesystem on $device is inconsistent" >>$here/$seq.full
+        echo "_check_xfs_filesystem: filesystem on $device is inconsistent (c) (see $seq.full)"
+
+        echo "_check_xfs_filesystem: filesystem on $device is inconsistent" >>$here/$seq.full
         echo "*** xfs_check output ***"                         >>$here/$seq.full
         cat $tmp.fs_check                                       >>$here/$seq.full
         echo "*** end xfs_check output"                         >>$here/$seq.full
-        
+
         ok=0
     fi
     # repair doesn't scale massively at this stage, optionally skip it for now
     [ "$USE_BIG_LOOPFS" = yes ] || \
-    $XFS_REPAIR_PROG -n $extra_log_options $device >$tmp.repair 2>&1
+    $XFS_REPAIR_PROG -n $extra_log_options $extra_rt_options $device >$tmp.repair 2>&1
     if [ $? -ne 0 ]
     then
-        echo "_check_fs: filesystem on $device is inconsistent (r) (see $seq.full)"
-        
-        echo "_check_fs: filesystem on $device is inconsistent" >>$here/$seq.full
+        echo "_check_xfs_filesystem: filesystem on $device is inconsistent (r) (see $seq.full)"
+
+        echo "_check_xfs_filesystem: filesystem on $device is inconsistent" >>$here/$seq.full
         echo "*** xfs_repair -n output ***"                     >>$here/$seq.full
         cat $tmp.repair | _fix_malloc                           >>$here/$seq.full
         echo "*** end xfs_repair output"                        >>$here/$seq.full
-        
+
         ok=0
     fi
     rm -f $tmp.fs_check $tmp.logprint $tmp.repair
+
     if [ $ok -eq 0 ]
     then
         echo "*** mount output ***"                             >>$here/$seq.full
@@ -730,7 +760,7 @@ _check_xfs_filesystem()
         echo "*** end mount output"                             >>$here/$seq.full
     elif [ "$type" = "xfs" ]
     then
-        # mounted... 
+        # mounted...
         if [ $USE_REMOUNT -eq 0 ]
         then
             if ! _mount -t xfs $extra_mount_options $device $mountpoint
@@ -742,19 +772,38 @@ _check_xfs_filesystem()
             _remount $device rw
         fi
     fi
-    
+
     [ $ok -eq 0 ] && exit 1
-    return 0    
+    return 0
+}
+
+# Filter the knowen errors the UDF Verifier reports.
+_udf_test_known_error_filter()
+{
+       egrep -v "PVD  60  Error: Interchange Level: 1, Maximum Interchange Level: 0|FSD  28  Error: Interchange Level: 1, Maximum Interchange Level: 1,|PVD  72  Warning: Volume Set Identifier: \"\*IRIX UDF\",|Warning: [0-9]+ unused blocks NOT marked as unallocated."
+
 }
 
 _check_udf_filesystem()
 {
+    [ "$DISABLE_UDF_TEST" == "1" ] && return
+
     if [ $# -ne 1 -a $# -ne 2 ]
     then
-       echo "Usage: _check_fs device [last_block]" 1>&2
+       echo "Usage: _check_udf_filesystem device [last_block]" 1>&2
        exit 1
     fi
 
+    if [ ! -x $here/src/udf_test ]
+    then
+       echo "udf_test not installed, please download and build the Philips"
+       echo "UDF Verification Software from http://www.extra.research.philips.com/udf/."
+       echo "Then copy the udf_test binary to $here/src/."
+       echo "If you do not wish to run udf_test then set environment variable DISABLE_UDF_TEST"
+       echo "to 1."
+       return
+    fi
+
     device=$1
     if [ $# -eq 2 ];
     then
@@ -762,37 +811,48 @@ _check_udf_filesystem()
         OPT_ARG="-lastvalidblock $LAST_BLOCK"
     fi
 
-    # Output messages format:
-    #       Error messages contain :   "Error:" or   "error:"
-    #     Warning messages contain : "Warning:" or "warning:"
-    #   Attention messages contain :    "Note:" or    "note:"
-    # Message continuation lines start with a "-" character.
-
     rm -f $seq.checkfs
     sleep 1 # Due to a problem with time stamps in udf_test
-    $here/src/udf_test $OPT_ARG $device | tee $here/$seq.checkfs | \
-       egrep -i "error:|warning:|Error count:|Warning count:" | \
-       egrep -v "Error count:   0|Warning count:   0"
+    $here/src/udf_test $OPT_ARG $device | tee $here/$seq.checkfs | egrep "Error|Warning" | \
+       _udf_test_known_error_filter | \
+       egrep -iv "Error count:.*[0-9]+.*total occurrences:.*[0-9]+|Warning count:.*[0-9]+.*total occurrences:.*[0-9]+" | \
+       sed "s/^.*$/Warning UDF Verifier reported errors see $seq.checkfs./g"
+
 }
 
 _check_test_fs()
 {
-    TEST_LOG=""
+    TEST_LOG="none"
+    TEST_RT="none"
     [ "$USE_EXTERNAL" = yes -a ! -z "$TEST_LOGDEV" ] && \
         TEST_LOG="$TEST_LOGDEV"
 
-    _check_xfs_filesystem $TEST_DEV $TEST_LOG
+    [ "$USE_EXTERNAL" = yes -a ! -z "$TEST_RTDEV" ] && \
+        TEST_RT="$TEST_RTDEV"
+
+    _check_xfs_filesystem $TEST_DEV $TEST_LOG $TEST_RT
+
+    # check for ipath consistency
+    if $XFS_GROWFS_PROG -n $TEST_DIR | grep -q 'inode-paths=1'; then
+       # errors go to stderr
+       xfs_check_ipaths $TEST_DIR >/dev/null
+       xfs_repair_ipaths -n $TEST_DIR >/dev/null
+    fi
 }
 
 _check_scratch_fs()
 {
     case $FSTYP in
     xfs)
-       SCRATCH_LOG=""
+       SCRATCH_LOG="none"
+       SCRATCH_RT="none"
        [ "$USE_EXTERNAL" = yes -a ! -z "$SCRATCH_LOGDEV" ] && \
            SCRATCH_LOG="$SCRATCH_LOGDEV"
 
-       _check_xfs_filesystem $SCRATCH_DEV $SCRATCH_LOG
+       [ "$USE_EXTERNAL" = yes -a ! -z "$SCRATCH_RTDEV" ] && \
+           SCRATCH_RT="$SCRATCH_RTDEV"
+
+       _check_xfs_filesystem $SCRATCH_DEV $SCRATCH_LOG $SCRATCH_RT
        ;;
     udf)
        _check_udf_filesystem $SCRATCH_DEV $udf_fsize
@@ -809,11 +869,19 @@ _full_fstyp_details()
 {
      [ -z "$FSTYP" ] && FSTYP=xfs
      if [ $FSTYP = xfs ]; then
-       if grep 'debug 0' /proc/fs/xfs/stat >/dev/null; then
-           FSTYP="$FSTYP (non-debug)"
-       elif grep 'debug 1' /proc/fs/xfs/stat >/dev/null; then
-           FSTYP="$FSTYP (debug)"
-       fi
+       if [ -d /proc/fs/xfs ]; then
+           if grep -q 'debug 0' /proc/fs/xfs/stat; then
+               FSTYP="$FSTYP (non-debug)"
+           elif grep -q 'debug 1' /proc/fs/xfs/stat; then
+               FSTYP="$FSTYP (debug)"
+           fi
+       else
+           if uname -a | grep -qi 'debug'; then
+               FSTYP="$FSTYP (debug)"
+           else
+               FSTYP="$FSTYP (non-debug)"
+           fi
+       fi
      fi
      echo $FSTYP
 }
@@ -851,11 +919,11 @@ _setup_xfs_testdir()
 {
     [ "$FSTYP" != "xfs" ] \
        && _fail "setup_xfs_testdir: \$FSTYP ($FSTYP) is not xfs"
-    
+
     testdir=$TEST_DIR
 }
 
-_setup_udf_testdir()
+_setup_udf_scratchdir()
 {
     [ "$FSTYP" != "udf" ] \
        && _fail "setup_udf_testdir: \$FSTYP is not udf"
@@ -863,17 +931,17 @@ _setup_udf_testdir()
        && _notrun "this test requires a valid \$SCRATCH_DEV"
     [ -z "$SCRATCH_MNT" ] \
        && _notrun "this test requires a valid \$SCRATCH_MNT"
-    
+
     # mounted?
     if _mount | grep -q $SCRATCH_DEV
-    then 
+    then
         # if it's mounted, make sure its on $TEST_RW_DIR
         if ! _mount | grep $SCRATCH_DEV | grep -q $SCRATCH_MNT
-        then 
+        then
             _fail "\$SCRATCH_DEV is mounted but not on \$SCRATCH_MNT - aborting"
         fi
        $UMOUNT_PROG $SCRATCH_DEV
-    fi 
+    fi
 
     _scratch_mkfs
     _scratch_mount
@@ -881,25 +949,25 @@ _setup_udf_testdir()
     testdir=$SCRATCH_MNT
 }
 
-_setup_nfs_testdir()
+_setup_nfs_scratchdir()
 {
     [ "$FSTYP" != "nfs" ] \
-       && _fail "setup_udf_testdir: \$FSTYP is not nfs"
+       && _fail "setup_nfs_testdir: \$FSTYP is not nfs"
     [ -z "$SCRATCH_DEV" ] \
        && _notrun "this test requires a valid host fs for \$SCRATCH_DEV"
     [ -z "$SCRATCH_MNT" ] \
        && _notrun "this test requires a valid \$SCRATCH_MNT"
-    
+
     # mounted?
     if _mount | grep -q $SCRATCH_DEV
-    then 
-        # if it's mounted, make sure its on $TEST_RW_DIR
+    then
+        # if it's mounted, make sure its on $SCRATCH_MNT
         if ! _mount | grep $SCRATCH_DEV | grep -q $SCRATCH_MNT
-        then 
+        then
             _fail "\$SCRATCH_DEV is mounted but not on \$SCRATCH_MNT - aborting"
         fi
        $UMOUNT_PROG $SCRATCH_DEV
-    fi 
+    fi
 
     _scratch_mkfs
     _scratch_mount
@@ -907,6 +975,11 @@ _setup_nfs_testdir()
     testdir=$SCRATCH_MNT
 }
 
+#
+# Warning for UDF and NFS this function calls _setup_udf_scratchdir and
+# _setup_udf_scratchdir. This is done because testdir is a persistent
+# XFS only partition.
+#
 _setup_testdir()
 {
     case $FSTYP in
@@ -914,15 +987,15 @@ _setup_testdir()
        _setup_xfs_testdir
        ;;
     udf)
-       _setup_udf_testdir
+       _setup_udf_scratchdir
        ;;
     nfs*)
-       _setup_nfs_testdir
+       _setup_nfs_scratchdir
        ;;
     *)
        _fail "\$FSTYP is not xfs, udf or nfs"
        ;;
-    esac    
+    esac
 }
 
 _cleanup_testdir()
@@ -930,6 +1003,7 @@ _cleanup_testdir()
     case $FSTYP in
     xfs)
        # do nothing, testdir is $TEST_DIR
+       :
        ;;
     udf)
        # umount testdir as it is $SCRATCH_MNT which could be used by xfs next
@@ -942,9 +1016,134 @@ _cleanup_testdir()
     *)
        _fail "\$FSTYP is not xfs, udf or nfs"
        ;;
-    esac    
+    esac
+}
+
+_link_out_file()
+{
+   if [ -z "$1" ]; then
+      echo Error must pass \$seq.
+      exit
+   fi
+   rm -f $1
+   if [ "`uname`" == "IRIX64" ] || [ "`uname`" == "IRIX" ]; then
+      ln -s $1.irix $1
+   elif [ "`uname`" == "Linux" ]; then
+      ln -s $1.linux $1
+   else
+      echo Error test $seq does not run on the operating system: `uname`
+      exit
+   fi
+}
+
+_die()
+{
+        echo $@
+        exit 1
+}
+
+_nfiles()
+{
+        f=0
+        while [ $f -lt $1 ]
+        do
+                file=f$f
+                touch $file
+                if [ $size -gt 0 ]; then
+                    dd if=/dev/zero of=$file bs=1024 count=$size
+                fi
+                f=`expr $f + 1`
+        done
+}
+
+# takes dirname, depth
+_descend()
+{
+        dirname=$1; depth=$2
+        mkdir $dirname  || die "mkdir $dirname failed"
+        cd $dirname
+
+        _nfiles $files           # files for this dir
+
+        [ $depth -eq 0 ] && return
+        deep=`expr $depth - 1`  # go 1 down
+
+        [ $verbose = true ] && echo "descending, depth from leaves = $deep"
+
+        d=0
+        while [ $d -lt $dirs ]
+        do
+                _descend d$d $deep &
+                d=`expr $d + 1`
+                wait
+        done
 }
 
+# Populate a filesystem with inodes for performance experiments
+#
+# usage: populate [-v] [-n ndirs] [-f nfiles] [-d depth] [-r root] [-s size]
+#
+_populate_fs()
+{
+    here=`pwd`
+    dirs=5          # ndirs in each subdir till leaves
+    size=0          # sizeof files in K
+    files=100       # num files in _each_ subdir
+    depth=2         # depth of tree from root to leaves
+    verbose=false
+    root=root       # path of initial root of directory tree
+
+    while getopts "d:f:n:r:s:v" c
+    do
+        case $c in
+        d)      depth=$OPTARG;;
+        n)      dirs=$OPTARG;;
+        f)      files=$OPTARG;;
+        s)      size=$OPTARG;;
+        v)      verbose=true;;
+        r)      root=$OPTARG;;
+        esac
+    done
+
+    _descend $root $depth
+    wait
+
+    cd $here
+
+    [ $verbose = true ] && echo done
+}
+
+# query whether the given file has the given inode flag set
+#
+_test_inode_flag()
+{
+    flag=$1
+    file=$2
+
+    if which $XFS_IO_PROG >/dev/null; then
+        if $XFS_IO_PROG -r -c 'lsattr -v' "$file" | grep -q "$flag" ; then
+           return 0
+        fi
+    fi
+    return 1
+}
+
+# query the given files extsize allocator hint in bytes (if any)
+#
+_test_inode_extsz()
+{
+    file=$1
+    blocks=""
+
+    if which $XFS_IO_PROG >/dev/null; then
+       blocks=`$XFS_IO_PROG -r -c 'stat' "$file" | \
+               awk '/^xattr.extsize =/ { print $3 }'`
+    fi
+    [ -z "$blocks" ] && blocks="0"
+    echo $blocks
+}
+
+
 ################################################################################
 
 if [ "$iam" != new -a "$iam" != bench ]
@@ -956,7 +1155,7 @@ then
         echo "common.rc: Error: \$TEST_DEV is not set"
         exit 1
     fi
-    
+
     # if $TEST_DEV is not mounted, mount it now as XFS
     if [ -z "`_fs_type $TEST_DEV`" ]
     then
@@ -972,32 +1171,14 @@ then
             fi
         fi
     fi
-    
-    if [ "`_fs_type $TEST_DEV`" != "xfs" ]
+
+    if [ "`_fs_type $TEST_DEV`" != "$FSTYP" ]
     then
-        echo "common.rc: Error: \$TEST_DEV ($TEST_DEV) is not a MOUNTED XFS filesystem"
+        echo "common.rc: Error: \$TEST_DEV ($TEST_DEV) is not a MOUNTED $FSTYP filesystem"
         $DF_PROG $TEST_DEV
         exit 1
     fi
-
 fi
 
-_link_out_file()
-{
-   if [ -z "$1" ]; then
-      echo Error must pass \$seq.
-      exit     
-   fi
-   rm -f $1
-   if [ "`uname`" == "IRIX64" ] || [ "`uname`" == "IRIX" ]; then
-      ln -s $1.irix $1
-   elif [ "`uname`" == "Linux" ]; then
-      ln -s $1.linux $1
-   else
-      echo Error test $seq does not run on the operating system: `uname`
-      exit
-   fi
-}
-
 # make sure this script returns success
 /bin/true